"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var CacheRecord = function () {
  function CacheRecord(value, ttl) {
    _classCallCheck(this, CacheRecord);

    this.value = value;
    this.exp = ttl + Date.now();
  }

  _createClass(CacheRecord, [{
    key: "isExpired",
    value: function isExpired() {
      var now = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : Date.now();

      return now > this.exp;
    }
  }]);

  return CacheRecord;
}();

var Cache = function () {
  function Cache() {
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        _ref$ttl = _ref.ttl,
        ttl = _ref$ttl === undefined ? 60000 : _ref$ttl;

    _classCallCheck(this, Cache);

    this.records = new Map();

    this.ttl = ttl;
  }

  _createClass(Cache, [{
    key: "get",
    value: function get(id) {
      if (this.has(id)) {
        return this.records.get(id).value;
      }

      return null;
    }
  }, {
    key: "has",
    value: function has(id) {
      var has = false;

      if (this.records.has(id)) {
        var record = this.records.get(id);

        if (record.isExpired()) {
          this.records.delete(id);
          has = false;
        } else {
          has = true;
        }
      }

      return has;
    }
  }, {
    key: "put",
    value: function put(id, value) {
      var ttl = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : this.ttl;

      var record = new CacheRecord(value, ttl);
      this.records.set(id, record);
    }
  }, {
    key: "clear",
    value: function clear(id) {
      if (id) {
        this.records.delete(id);
      } else {
        this.records = new Map();
      }
    }
  }]);

  return Cache;
}();

exports.default = Cache;