'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CLIENT_REQUEST_SETUP_ERROR = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = api;

var _clientRequest = require('./clientRequest');

var _clientRequest2 = _interopRequireDefault(_clientRequest);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var CLIENT_REQUEST_SETUP_ERROR = exports.CLIENT_REQUEST_SETUP_ERROR = 'CLIENT_REQUEST_SETUP_ERROR';

function apiRequestTemplate(template, apiOptions, requestOptions) {
  var getRequestExecuteFunction = (0, _clientRequest2.default)(template, apiOptions);

  var apiRequest = function apiRequest() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var context = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    var error = null;
    var executeRequest = null;

    try {
      executeRequest = getRequestExecuteFunction(params);
    } catch (e) {
      error = {
        ok: false,
        message: e.message,
        type: CLIENT_REQUEST_SETUP_ERROR,
        error: e
      };
    }

    if (error) {
      return Promise.reject(error);
    } else {
      return executeRequest({
        headers: _extends({}, context.headers, requestOptions.headers)
      });
    }
  };

  apiRequest.displayName = 'API: ' + template;
  apiRequest.stringify = function (params) {
    return getRequestExecuteFunction.stringify(params);
  };

  return apiRequest;
}

function api() {
  var apiOptions = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  return function (template) {
    var requestOptions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    return apiRequestTemplate(template, apiOptions, requestOptions);
  };
}