'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

exports.default = getRequestTempalate;

var _formData = require('form-data');

var _formData2 = _interopRequireDefault(_formData);

var _url = require('url');

var _url2 = _interopRequireDefault(_url);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var getUniqueBindings = function getUniqueBindings(queryBindings, pathBindings) {
  return new Set([].concat(_toConsumableArray(queryBindings), _toConsumableArray(pathBindings)));
};

var buildQuery = function buildQuery(queryBindings, queryDefaults, paramsMap) {
  var query = {};

  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = queryDefaults[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var def = _step.value;

      query[def.key] = def.value;
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  var _iteratorNormalCompletion2 = true;
  var _didIteratorError2 = false;
  var _iteratorError2 = undefined;

  try {
    for (var _iterator2 = queryBindings[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
      var key = _step2.value;

      if (paramsMap.has(key)) {
        query[key] = paramsMap.get(key);
      }
    }
  } catch (err) {
    _didIteratorError2 = true;
    _iteratorError2 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion2 && _iterator2.return) {
        _iterator2.return();
      }
    } finally {
      if (_didIteratorError2) {
        throw _iteratorError2;
      }
    }
  }

  return query;
};

var buildPath = function buildPath(path, paramsMap) {
  return path.replace(/:([\w\d]+)/g, function (str, paramName) {
    if (!paramsMap.has(paramName)) {
      throw new Error('could not build path ("' + path + '") - param "' + paramName + '" does not exist');
    }

    return paramsMap.get(paramName);
  });
};

var buildUnboundParams = function buildUnboundParams(exceptParamsSet) {
  var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  var keys = params.entries ? params.entries() : Object.keys(params);
  var isIterator = !!params.entries;

  var newParams = isIterator ? new _formData2.default() : {};

  var _iteratorNormalCompletion3 = true;
  var _didIteratorError3 = false;
  var _iteratorError3 = undefined;

  try {
    for (var _iterator3 = keys[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
      var pair = _step3.value;

      var key = isIterator ? pair[0] : pair;

      if (exceptParamsSet.has(key)) {
        continue;
      }

      if (isIterator) {
        newParams.set(pair[0], pair[1]);
      } else {
        newParams[pair] = params[pair];
      }
    }
  } catch (err) {
    _didIteratorError3 = true;
    _iteratorError3 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion3 && _iterator3.return) {
        _iterator3.return();
      }
    } finally {
      if (_didIteratorError3) {
        throw _iteratorError3;
      }
    }
  }

  return newParams;
};

var fNot = function fNot(f) {
  return function (a) {
    return !f(a);
  };
};

var getTemplateBinding = function getTemplateBinding(str) {
  var matches = str.match(/^:([\w\d]+)$/);
  return matches ? matches[1] : null;
};

var extractQueryBindings = function extractQueryBindings(url) {
  return Object.keys(url.query).map(getTemplateBinding).filter(function (it) {
    return it !== null;
  });
};

var extractQueryDefaults = function extractQueryDefaults(url) {
  return Object.keys(url.query).filter(fNot(getTemplateBinding)).map(function (it) {
    return [it, url.query[it]];
  });
};

var extractPathBindings = function extractPathBindings(url) {
  return url.pathname.split('/').map(getTemplateBinding).filter(function (it) {
    return it !== null;
  });
};

var extractMethodAndUrl = function extractMethodAndUrl(templateString) {
  var parts = templateString.match(/^([a-z]+)\s(.+)$/i);
  var method = 'GET';
  var url = templateString;

  if (parts) {
    method = parts[1].toUpperCase();
    url = parts[2];
  }

  return [method, url];
};

var getParamsMap = function getParamsMap(params) {
  var isIterator = !!params.entries;
  var keys = isIterator ? params.entries() : Object.keys(params);

  var paramsMap = new Map();
  var _iteratorNormalCompletion4 = true;
  var _didIteratorError4 = false;
  var _iteratorError4 = undefined;

  try {
    for (var _iterator4 = keys[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
      var pair = _step4.value;

      if (isIterator) {
        paramsMap.set(pair[0], pair[1]);
      } else {
        paramsMap.set(pair, params[pair]);
      }
    }
  } catch (err) {
    _didIteratorError4 = true;
    _iteratorError4 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion4 && _iterator4.return) {
        _iterator4.return();
      }
    } finally {
      if (_didIteratorError4) {
        throw _iteratorError4;
      }
    }
  }

  return paramsMap;
};

var parseRequestTemplate = function parseRequestTemplate(templateString) {
  var _extractMethodAndUrl = extractMethodAndUrl(templateString),
      _extractMethodAndUrl2 = _slicedToArray(_extractMethodAndUrl, 2),
      httpMethod = _extractMethodAndUrl2[0],
      urlTemplate = _extractMethodAndUrl2[1];

  var url = _url2.default.parse(urlTemplate, true);
  var queryBindings = extractQueryBindings(url);
  var queryDefaults = extractQueryDefaults(url);
  var pathBindings = extractPathBindings(url);

  return {
    httpMethod: httpMethod,
    queryBindings: queryBindings,
    queryDefaults: queryDefaults,
    pathBindings: pathBindings,
    path: url.pathname
  };
};

var methodsWithBody = new Set(['POST', 'PUT', 'PATCH']);

function getRequestTempalate(tempalte) {
  var _parseRequestTemplate = parseRequestTemplate(tempalte),
      httpMethod = _parseRequestTemplate.httpMethod,
      queryBindings = _parseRequestTemplate.queryBindings,
      queryDefaults = _parseRequestTemplate.queryDefaults,
      pathBindings = _parseRequestTemplate.pathBindings,
      path = _parseRequestTemplate.path;

  var uniqueBindings = getUniqueBindings(queryBindings, pathBindings);

  return function getRequest() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var paramsMap = getParamsMap(params);
    var request = {};

    var body = null;
    var unboundQuery = {};

    if (methodsWithBody.has(httpMethod)) {
      body = buildUnboundParams(uniqueBindings, params);
      request.body = body;
    } else {
      unboundQuery = buildUnboundParams(uniqueBindings, params);
    }

    return _extends({}, request, {
      query: _extends({}, buildQuery(queryBindings, queryDefaults, paramsMap), unboundQuery),
      path: buildPath(path, paramsMap),
      method: httpMethod
    });
  };
}