'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var isFunction = function isFunction(func) {
  return func && {}.toString.call(func) === '[object Function]';
};

var mockDataSource = function mockDataSource(ds, mockFn) {
  var mocks = {};

  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = ds.getSteps()[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var stepId = _step.value;

      if (isFunction(stepId)) {
        ds.constructor[stepId] = mockFn(ds.constructor[stepId]);
        mocks[stepId] = ds.constructor[stepId];
      } else {
        var stepConfig = ds.constructor[stepId] || {};
        mocks[stepId] = {};

        var _iteratorNormalCompletion2 = true;
        var _didIteratorError2 = false;
        var _iteratorError2 = undefined;

        try {
          for (var _iterator2 = Object.keys(stepConfig)[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
            var methodId = _step2.value;

            stepConfig[methodId] = mockFn(stepConfig[methodId]);
            mocks[stepId][methodId] = stepConfig[methodId];
          }
        } catch (err) {
          _didIteratorError2 = true;
          _iteratorError2 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion2 && _iterator2.return) {
              _iterator2.return();
            }
          } finally {
            if (_didIteratorError2) {
              throw _iteratorError2;
            }
          }
        }
      }
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return mocks;
};

exports.default = mockDataSource;