"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = promiseCache;
function promiseCache(cache, key, fn, ttl) {
  return new Promise(function (resolve, reject) {
    var previouslyCached = cache.get(key);

    if (null !== previouslyCached) {
      resolve(previouslyCached);
      return;
    }

    fn().then(function (result) {
      cache.put(key, result, ttl);
      resolve(result);
    }, function (err) {
      reject(err);
    });
  });
}